searchData={"items":[{"type":"module","title":"Mua","doc":"Minimal SMTP client.","ref":"Mua.html"},{"type":"function","title":"Mua.auth/4","doc":"Sends `AUTH` extension command and authenticates the sender.\n\n    :ok = auth(socket, :login, username: username, password: password)\n    :ok = auth(socket, :plain, username: username, password: password)","ref":"Mua.html#auth/4"},{"type":"function","title":"Mua.close/1","doc":"Closes connection to the SMTP server.\n\n    :ok = close(socket)","ref":"Mua.html#close/1"},{"type":"function","title":"Mua.connect/5","doc":"Connects to an SMTP server and receives its banner.\n\n    {:ok, socket, _banner} = connect(:tcp, host, _port = 25)\n    {:ok, socket, _banner} = connect(:ssl, host, _port = 465, versions: [:\"tlsv1.3\"])","ref":"Mua.html#connect/5"},{"type":"function","title":"Mua.data/3","doc":"Sends `DATA` command that specifies the beginning of the mail, and then sends the message.\n\n    {:ok, _receipt} = data(socket, \"Date: Sat, 24 Jun 2023 13:43:57 +0000\\r\\n...\")","ref":"Mua.html#data/3"},{"type":"function","title":"Mua.easy_send/5","doc":"Utility function to send a message to a list of recipients on a host.\n\n    {:ok, _receipt} =\n      easy_send(\n        _host = \"gmail.com\",\n        _sender = \"mua@github.com\",\n        _recipients = [\"support@gmail.com\"],\n        _message = \"Date: Sat, 24 Jun 2023 13:43:57 +0000\\r\\n...\"\n      )","ref":"Mua.html#easy_send/5"},{"type":"function","title":"Mua.ehlo/3","doc":"Sends `EHLO` command which provides the identification of the sender i.e. the host name,\nand receives the list of extensions the server supports.\n\n    {:ok, _extensions = [\"STARTTLS\" | _rest]} = ehlo(socket, _our_hostname = \"copycat.fun\")","ref":"Mua.html#ehlo/3"},{"type":"function","title":"Mua.guess_sender_hostname/0","doc":"Utility function to guess the local hostname to use for HELO/EHLO.\n\n    {:ok, \"mac3\"} = guess_sender_hostname()","ref":"Mua.html#guess_sender_hostname/0"},{"type":"function","title":"Mua.helo/3","doc":"Sends `HELO` command which provides the identification of the sender i.e. the host name.\n\n    :ok = helo(socket, _our_hostname = \"copycat.fun\")","ref":"Mua.html#helo/3"},{"type":"function","title":"Mua.mail_from/3","doc":"Sends `MAIL FROM` command that specifies the originator of the mail.\n\n    :ok = mail_from(socket, \"hey@copycat.fun\")","ref":"Mua.html#mail_from/3"},{"type":"function","title":"Mua.mxlookup/1","doc":"Utility function to lookup MX servers for a domain.\n\n    [\"gmail-smtp-in.l.google.com\" | _rest] = mxlookup(\"gmail.com\")","ref":"Mua.html#mxlookup/1"},{"type":"function","title":"Mua.noop/2","doc":"Sends `NOOP` command that does nothing.\n\n    :ok = noop(socket)","ref":"Mua.html#noop/2"},{"type":"function","title":"Mua.pick_auth_method/1","doc":"Utility function to pick a supported auth method from a list of extensions.\n\n    {:ok, extensions} = ehlo(socket, hostname)\n    maybe_method = pick_auth_method(extensions)\n    true = maybe_method in [nil, :plain, :login]","ref":"Mua.html#pick_auth_method/1"},{"type":"function","title":"Mua.quit/2","doc":"Sends `QUIT` command that make the server close the connection.\n\n    :ok = quit(socket)","ref":"Mua.html#quit/2"},{"type":"function","title":"Mua.rcpt_to/3","doc":"Sends `RCPT TO` command that specify the recipient of the mail.\n\n    :ok = rcpt_to(socket, \"world@hey.com\")","ref":"Mua.html#rcpt_to/3"},{"type":"function","title":"Mua.rset/2","doc":"Sends `RSET` command that aborts the current mail transaction but keeps the socket open.\n\n    :ok = rset(socket)","ref":"Mua.html#rset/2"},{"type":"function","title":"Mua.starttls/4","doc":"Sends `STARTTLS` extension command and starts TLS session negotiation.\n\n    {:ok, sslsocket} = starttls(socket, host, versions: [:\"tlsv1.3\"])","ref":"Mua.html#starttls/4"},{"type":"function","title":"Mua.vrfy/3","doc":"Sends `VRFY` command that confirms or verifies the user name.\n\n    {:ok, true} = vrfy(socket, \"dogaruslan@gmail.com\")","ref":"Mua.html#vrfy/3"},{"type":"type","title":"Mua.auth_method/0","doc":"","ref":"Mua.html#t:auth_method/0"},{"type":"type","title":"Mua.error/0","doc":"","ref":"Mua.html#t:error/0"},{"type":"type","title":"Mua.host/0","doc":"","ref":"Mua.html#t:host/0"},{"type":"type","title":"Mua.option/0","doc":"","ref":"Mua.html#t:option/0"},{"type":"type","title":"Mua.proto/0","doc":"","ref":"Mua.html#t:proto/0"},{"type":"type","title":"Mua.socket/0","doc":"","ref":"Mua.html#t:socket/0"},{"type":"type","title":"Mua.transport_opts/0","doc":"","ref":"Mua.html#t:transport_opts/0"},{"type":"exception","title":"Mua.SMTPError","doc":"An SMTP error.\n\nContains the following fields:\n\n  - `:code` - [SMTP error code](https://en.wikipedia.org/wiki/List_of_SMTP_server_return_codes)\n  - `:lines` - lines received from the server","ref":"Mua.SMTPError.html"},{"type":"function","title":"Mua.SMTPError.message/1","doc":"","ref":"Mua.SMTPError.html#message/1"},{"type":"type","title":"Mua.SMTPError.t/0","doc":"","ref":"Mua.SMTPError.html#t:t/0"},{"type":"exception","title":"Mua.TransportError","doc":"Represents an error with the transport used by an SMTP connection.\n\nContains the following fields:\n\n  - `:reason` - a term representing the error reason. The value of this field\n    can be:\n\n      - `:timeout` - if there's a timeout in interacting with the socket.\n\n      - `:closed` - if the connection has been closed.\n\n      - `t::inet.posix/0` - if there's any other error with the socket,\n        such as `:econnrefused` or `:nxdomain`.\n\n      - `t::ssl.error_alert/0` - if there's an SSL error.","ref":"Mua.TransportError.html"},{"type":"function","title":"Mua.TransportError.message/1","doc":"","ref":"Mua.TransportError.html#message/1"},{"type":"type","title":"Mua.TransportError.t/0","doc":"","ref":"Mua.TransportError.html#t:t/0"},{"type":"extras","title":"Mua","doc":"# Mua\n\n[![Hex Package](https://img.shields.io/hexpm/v/mua.svg)](https://hex.pm/packages/mua)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/mua)\n\nMinimal SMTP client (aka Mail user agent).\n\nCan be used with [Bamboo](https://github.com/ruslandoga/bamboo_mua) and [Swoosh.](https://github.com/ruslandoga/swoosh_mua)\n\n#","ref":"readme.html"},{"type":"extras","title":"Features - Mua","doc":"- Direct messaging (no relays)\n- Inderect messaging (relays)\n- Minimal API\n- Processless","ref":"readme.html#features"},{"type":"extras","title":"Installation - Mua","doc":"```elixir\ndefp deps do\n  [\n    {:mua, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Mua","doc":"This demo will use [MailHog:](https://github.com/mailhog/MailHog)\n\n```console\n$ docker run -d --rm -p 1025:1025 -p 8025:8025 --name mailhog mailhog/mailhog\n$ open http://localhost:8025\n```\n\nHigh-level API:\n\n```elixir\nmessage = \"\"\"\nDate: Mon, 25 Dec 2023 06:52:15 +0000\\r\nFrom: Mua  \\r\nSubject: README\\r\nTo: Mr Receiver  \\r\nCC: Ms Receiver  \\r\n\\r\nlike and subscribe\\r\n.\\r\n\"\"\"\n\n{:ok, _receipt} =\n  Mua.easy_send(\n    _host = \"localhost\",\n    _mail_from = \"mua@github.com\",\n    _rcpt_to = [\"receiver1@mailhog.example\", \"receiver2@mailhog.example\"],\n    message,\n    port: 1025,\n    auth: [username: \"username\", password: \"password\"] \n  )\n```\n\nLow-level API:\n\n```elixir\n{:ok, socket, _banner} = Mua.connect(:tcp, \"localhost\", _port = 1025)\n{:ok, extensions} = Mua.ehlo(socket, _sending_domain = \"github.com\")\n\n{:ok, socket} = \n  if \"STARTTLS\" in extensions do\n    Mua.starttls(socket, \"localhost\")\n  else\n    {:ok, _stay_plain_text = socket}\n  end\n\n:plain = Mua.pick_auth_method(extensions)\n:ok = Mua.auth(socket, :plain, username: \"username\", password: \"password\")\n\n:ok = Mua.mail_from(socket, \"mua@github.com\")\n:ok = Mua.rcpt_to(socket, \"receiver@mailhog.example\")\n\nmessage =\n  \"\"\"\n  Date: Mon, 25 Dec 2023 06:52:15 +0000\\r\n  From: Mua  \\r\n  Subject: How was your day?\\r\n  To: Mr Receiver  \\r\n  \\r\n  Mine was fine.\\r\n  .\\r\n  \"\"\"\n\n{:ok, _receipt} = Mua.data(socket, message)\n:ok = Mua.close(socket)\n```","ref":"readme.html#usage"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.1.5 (2023-12-26) - Changelog","doc":"- cleanup API and update docs","ref":"changelog.html#v0-1-5-2023-12-26"},{"type":"extras","title":"v0.1.4 (2023-09-09) - Changelog","doc":"- do `EHLO` or `HELO` after `STARTTLS` https://github.com/ruslandoga/mua/pull/7","ref":"changelog.html#v0-1-4-2023-09-09"},{"type":"extras","title":"v0.1.3 (2023-07-14) - Changelog","doc":"- add `Mua.TransportError` like in [Mint](https://github.com/elixir-mint/mint/blob/main/lib/mint/transport_error.ex) https://github.com/ruslandoga/mua/pull/6","ref":"changelog.html#v0-1-3-2023-07-14"},{"type":"extras","title":"v0.1.2 (2023-07-14) - Changelog","doc":"- refactor `AUTH` https://github.com/ruslandoga/mua/pull/5","ref":"changelog.html#v0-1-2-2023-07-14"},{"type":"extras","title":"v0.1.1 (2023-07-14) - Changelog","doc":"- add `AUTH` https://github.com/ruslandoga/mua/pull/4","ref":"changelog.html#v0-1-1-2023-07-14"}],"content_type":"text/markdown"}